# Assignment 7 指南

## `******注意，实验结束请立即删除云主机、UFS文件存储和UAI Train交互式训练任务，节省费用******` 

## `******注意2，实验未结束且短期内不会继续实验，也请删除所有上述资源。下次实验时重新创建******` 


##  实验内容

- 创建文件存储: `实验步骤 一)` 
- 创建云主机，并挂载文件存储：`实验步骤 二)`
- 在文件存储中创建一个项目文件夹，并在学院GitLab中新建一个同步仓库：`实验步骤 三)`
- 创建UAI Train交互式训练任务，启动并切换成编辑模式: `实验步骤  四)`
- 使用交互式训练任务训练一个能够识别MNIST手写数字的神经网络：`实验步骤 五)`

## 实验要求

- 完成所有步骤，并在实验报告（[模板下载](file/assignment7/学号-实验七.docx))中完成穿插在本指南中的作业1～作业4）。实验报告转成“学号-实验七.pdf”，并上传至http://113.31.104.68:3389/index.htm
- 实验报告上传deadline： `12月4日`

## 使用UCloud产品 

云主机UHost、文件存储UFS、镜像库UHub、AI训练UAI Train、私有网络VPC、基础网络UNet

## 需要权限

云主机UHost、文件存储UFS、镜像库UHub、AI训练UAI Train、基础网络UNet


## 基础知识


`MNIST:` MNIST是一个手写数字数据库，包含60000个训练样本和10000个测试样本，是一个能够快速上手的、用于尝试机器学习和模式识别技术的数据集。以下是部分MNIST中的样本。

<kbd>
  <img src="img/assignment7/ass7-mnist.png">
</kbd>


## 实验步骤

### 一）创建一个文件存储

#### 1）在产品->存储中选择“文件存储UFS”，然后点击创建文件系统。

#### 2）如下图，存储类型选择SSD性能型，100GB，按时付费。

<kbd>
  <img src="img/assignment7/ass7-createufs.png">
</kbd>

#### 3）创建完毕后，点击添加挂载点，如下图所示选择一个VPC网络，使得相应的子网是DefaultNetwork，点击确定。这样我们等一下在DefaultNetwork下面创建一个云主机，就能把这个文件存储挂载到云主机上。

<kbd>
  <img src="img/assignment7/ass7-setmount.png">
</kbd>

#### 4）点击“管理挂载”，查看挂载信息，记住文件存储所在的ip地址，第二）步中我们把这个文件存储挂在到云主机上。

<kbd>
  <img src="img/assignment7/ass7-mountinfo.png">
</kbd>


### 二）将文件存储挂载到云主机上，使得它在逻辑上成为云主机的一个分区

#### 1）创建一个1核1G的云主机，绑定弹性IP，按时付费（这个云主机必须在文件存储所挂载的子网中，否则无法和文件存储通信）

#### 2）登录云主机，安装NFS

```
sudo yum install -y nfs-utils
```

NFS（Network File System）是一个能够使得本地主机访问远程主机文件系统的应用程序。因为步骤一）创建的文件存储对于当前的云主机来讲是一个远程存储（网络存储），使用NFS协议才能将其挂载到当前云主机上。

#### 3）在云主机上挂载文件存储，挂载点为/mnt

```
sudo yum mount -t nfs4 你的文件存储IP地址:/ /mnt
```

#### 4）运行如下命令查看当前云主机的文件系统

```
df -hT
```

你应该看到如下图所示内容，其中
<kbd>
  <img src="img/assignment6/ass6-llq.jpeg">
</kbd>

#### 4）将云主机连到负载均衡器。回到前面添加服务节点的界面，输入端口80，则所有可添加的节点都会出现（以内网ip形式）。将你的云主机对应的内网ip，转移到待添加节点，点击确定。这时候显示健康检查“失败”，不用管它，我们在浏览器中输入 `http://你的负载均衡器ip`，奇迹发生了！我们也能访问flask app！！并且这时候健康检查也变成“正常”。

<kbd>
  <img src="img/assignment6/ass6-addserver.jpeg">
</kbd>


## `**************作业1：请将浏览器中通过负载均衡ip访问flask app的界面，以及负载均衡器中服务节点界面截图，并插入实验报告***************`

#### 5）此时负载均衡器只连接了一个服务实例，等同于单机访问。`为步骤三做准备，请在这一步制作当前云主机的镜像`。


### 三）使用ab进行http服务器压力测试

#### 1）使用步骤二）中制作的镜像，创建三个最低配置的云主机（`和之前一样，只是在云主机创建界面用“自制镜像”，并且不需要弹性ip`），可以选择三台主机一次性创建

<kbd>
  <img src="img/assignment6/ass6-createuh.png">
</kbd>

#### 2）创建完毕后，使用有外网ip的那台云主机，逐个ssh到三台内网机器上（通过内网ip），然后每台机器直接启动docker服务，并运行flask app容器（因为已经全都安装并且build好了 :smiley_cat: :smiley_cat: :smiley_cat:）

<kbd>
  <img src="img/assignment6/ass6-intra.jpeg">
</kbd>

<kbd>
  <img src="img/assignment6/ass6-intrassh.jpeg">
</kbd>

#### 3）现在让我们把这三个云主机连接到负载均衡器，并且从负载均衡器中删除刚才的具有外网ip的节点（接下来我们要用外网ip节点做压测）。首先我们禁用掉其中的两个节点，只保留一个节点在启用状态。如下图所示。

<kbd>
  <img src="img/assignment6/ass6-3s.jpeg">
</kbd>

## `**************作业2：请将此时连接到负载均衡的服务节点（三个）截图，并插入实验报告***************`

#### 4）登录具有外网ip的云主机，安装ApacheBench
```
sudo yum -y install httpd
```

#### 5）运行压测命令。`-c`表示并发数，即同时发生的请求数，`-n`表示请求总数，`http://106.75.216.169/`替换成你的负载均衡器ip。所以这里对我们的flask app并发1000个请求，总共发出10000个请求。结果如下图所示。
```
ab -c 1000 -n 10000 http://106.75.216.169/
```

<kbd>
  <img src="img/assignment6/ass6-ab.jpeg">
</kbd>

> 这里我们关注几个重要结果

> 1) Time taken for tests：压测总时间

> 2) Requests per second: 平均每秒处理请求数

> 3) Time per request: 平均每个请求处理时间

#### 6）接下来，请逐渐启用第2和第3个服务器节点，然后再运行上面的压测命令。

## `**************作业3：请将启用一个节点、两个节点、三个节点时的压测结果分别截图，并插入实验报告***************`

注意，由于有网络因素干扰，每个实验你可以多进行几次压测，得到比较正常的结果再截图。

## `**************作业4：假设现在压测结果显示单台机器的Requests per second为30，一天中的请求峰值时间是2个小时，总共需要处理5千万个请求，请问需要至少准备多少台机器才可能平稳度过峰值请求？***************`
